=== coreboot/cros/util/coreboot-configurator/contrib/debian/control ===
Source: coreboot-configurator
Section: utils
Priority: optional
Maintainer: Star Labs <admin@starlabs.systems>
Build-Depends: build-essential, cmake, debhelper (>= 7), inkscape, libqt5gui5, libqt5svg5-dev, libyaml-cpp-dev, libqt5gui5, meson, pkg-config, qtbase5-dev, qttools5-dev-tools
Standards-Version: 4.1.1

Package: coreboot-configurator
Depends: nvramtool, ${shlibs:Depends}, ${misc:Depends}, libqt5gui5, qt5-style-plugins, libyaml-cpp0.6
Architecture: all
Description: Graphical interface to change settings available in coreboot CBFS
